BLAKE2_Base< W, T_64bit > Class Template Reference

BLAKE2 hash implementation. More...

Inheritance diagram for BLAKE2_Base< W, T_64bit >:

## Public Types

typedef BLAKE2_State< W, T_64bit > | State
typedef BLAKE2_ParameterBlock< T_64bit > | ParameterBlock
typedef SecBlock< State, AllocatorWithCleanup< State, true > > | AlignedState
typedef SecBlock< ParameterBlock, AllocatorWithCleanup< ParameterBlock, true > > | AlignedParameterBlock
Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Public Member Functions

std::string | AlgorithmName () const
| Retrieve the object's name. More...
unsigned int | DigestSize () const
| Provides the digest size of the hash. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
void | Update (const byte *input, size_t length)
| Updates a hash with additional input. More...
void | Restart ()
| Restart the hash. More...
void | Restart (const BLAKE2_ParameterBlock< T_64bit > &block, const W counter[2])
| Restart a hash with parameter block and counter. More...
void | SetTreeMode (bool mode)
| Set tree mode. More...
bool | GetTreeMode () const
| Get tree mode. More...
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message. More...
Public Member Functions inherited from SimpleKeyingInterfaceImpl< MessageAuthenticationCode, BLAKE2_Info< T_64bit > >
size_t | MinKeyLength () const
| The minimum key length used by the algorithm. More...
size_t | MaxKeyLength () const
| The maximum key length used by the algorithm. More...
size_t | DefaultKeyLength () const
| The default key length used by the algorithm. More...
size_t | GetValidKeyLength (size_t keylength) const
| Provides a valid key length for the algorithm. More...
SimpleKeyingInterface::IV_Requirement | IVRequirement () const
| The default IV requirements for the algorithm. More...
unsigned int | IVSize () const
| The default initialization vector length for the algorithm. More...
Public Member Functions inherited from SimpleKeyingInterface
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length. More...
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs returns whether the object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV), false otherwise.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object. More...
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual void | Final (byte *digest)
| Computes the hash of the current message. More...
unsigned int | TagSize () const
| Provides the tag size of the hash. More...
virtual unsigned int | BlockSize () const
| Provides the block size of the compression function. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash. More...
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message. More...
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message. More...
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message. More...
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Static Public Member Functions

static const char * | StaticAlgorithmName ()
| Retrieve the static algorithm name. More...

## Static Public Attributes

static const int | DEFAULT_KEYLENGTH = BLAKE2_Info<T_64bit>::DEFAULT_KEYLENGTH
static const int | MIN_KEYLENGTH = BLAKE2_Info<T_64bit>::MIN_KEYLENGTH
static const int | MAX_KEYLENGTH = BLAKE2_Info<T_64bit>::MAX_KEYLENGTH
static const int | DIGESTSIZE = BLAKE2_Info<T_64bit>::DIGESTSIZE
static const int | BLOCKSIZE = BLAKE2_Info<T_64bit>::BLOCKSIZE
static const int | SALTSIZE = BLAKE2_Info<T_64bit>::SALTSIZE
static const int | PERSONALIZATIONSIZE = BLAKE2_Info<T_64bit>::PERSONALIZATIONSIZE

## Detailed Description

### template<class W, bool T_64bit>
class BLAKE2_Base< W, T_64bit >

BLAKE2 hash implementation.

Template Parameters

  W | word type
  T_64bit | flag indicating 64-bit

BLAKE2b uses BLAKE2_Base<word64, true>, while BLAKE2s uses BLAKE2_Base<word32, false>.

Since
  Crypto++ 5.6.4

Definition at line 162 of file blake2.h.

## Member Function Documentation

## StaticAlgorithmName()

template<class W, bool T_64bit>

static const char* BLAKE2_Base< W, T_64bit >::StaticAlgorithmName | ( |  | ) |

inline static

Retrieve the static algorithm name.

Returns
  the algorithm name (BLAKE2s or BLAKE2b)

Definition at line 183 of file blake2.h.

## AlgorithmName()

template<class W, bool T_64bit>

std::string BLAKE2_Base< W, T_64bit >::AlgorithmName | ( |  | ) | const

inline virtual

Retrieve the object's name.

Returns
  the object's algorithm name following RFC 7693

Object algorithm name follows the naming described in RFC 7693, The BLAKE2 Cryptographic Hash and Message Authentication Code (MAC). For example, "BLAKE2b-512" and "BLAKE2s-256".

Reimplemented from Algorithm.

Definition at line 190 of file blake2.h.

## DigestSize()

template<class W, bool T_64bit>

unsigned int BLAKE2_Base< W, T_64bit >::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 192 of file blake2.h.

## OptimalDataAlignment()

template<class W, bool T_64bit>

unsigned int BLAKE2_Base< W, T_64bit >::OptimalDataAlignment | ( |  | ) | const

inline virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

Reimplemented from HashTransformation.

Definition at line 193 of file blake2.h.

## Update()

template<class W , bool T_64bit>

void BLAKE2_Base< W, T_64bit >::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |

virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 415 of file blake2.cpp.

## Restart() [1/2]

template<class W , bool T_64bit>

void BLAKE2_Base< W, T_64bit >::Restart | ( |  | ) |

virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

Definition at line 377 of file blake2.cpp.

## Restart() [2/2]

template<class W, bool T_64bit>

void BLAKE2_Base< W, T_64bit >::Restart | ( | const BLAKE2_ParameterBlock< T_64bit > & | block,
|  | const W | counter[2]
| ) |  |

Restart a hash with parameter block and counter.

Parameters

  block | paramter block
  counter | counter array

Parameter block is persisted across calls to Restart().

Definition at line 384 of file blake2.cpp.

## SetTreeMode()

template<class W, bool T_64bit>

void BLAKE2_Base< W, T_64bit >::SetTreeMode | ( | bool | mode | ) |

inline

Set tree mode.

Parameters

  mode | the new tree mode

BLAKE2 has two finalization flags, called State::f[0] and State::f[1]. If `treeMode=false` (default), then State::f[1] is never set. If `treeMode=true`, then State::f[1] is set when State::f[0] is set. Tree mode is persisted across calls to Restart().

Definition at line 210 of file blake2.h.

## GetTreeMode()

template<class W, bool T_64bit>

bool BLAKE2_Base< W, T_64bit >::GetTreeMode | ( |  | ) | const

inline

Get tree mode.

Returns
  the current tree mode

Tree mode is persisted across calls to Restart().

Definition at line 215 of file blake2.h.

## TruncatedFinal()

template<class W , bool T_64bit>

void BLAKE2_Base< W, T_64bit >::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() call Final() and then copies digestSize bytes to digest

TruncatedFinal() restarts the hash for the next message.

Precondition
  `COUNTOF(digest) == DigestSize()` or `COUNTOF(digest) == HASH::DIGESTSIZE` ensures the output byte buffer is large enough for the digest.

Implements HashTransformation.

Definition at line 449 of file blake2.cpp.

The documentation for this class was generated from the following files:

- blake2.h
- blake2.cpp